/*
 * Terminal IIIMCF interface 0.6.1.8
 *   - test code
 */

#include <stdio.h>
#include <stdlib.h>
#include <iiimcf.h>
#include "tii.h"

int
main(void)
{
	int i, j;
	char ** im_list, ** lang_list;

	IIIMCF_handle handle = NULL;
	IIIMCF_context context = NULL;

	if(!tii_init_iiimcf()) goto exit;

	handle = tii_create_handle();
	if(handle == NULL) goto exit;

	/* for Korean (hangul) */
	IIIMCF_input_method im = tii_find_im(handle, "hangul");
	IIIMCF_language lang = tii_find_lang(handle, "hangul", "ko");

	/* for Chinese (newpy) */
/*	IIIMCF_input_method im = tii_find_im(handle, "newpy");
	IIIMCF_language lang = tii_find_lang(handle, "newpy", "zh_CN");
*/
	/* for Japanese (CannaLE, need cannaserver) */
/*	IIIMCF_input_method im = tii_find_im(handle, "CannaLE");
	IIIMCF_language lang = tii_find_lang(handle, "CannaLE", "ja");
*/
	if(im == NULL || lang == NULL) goto exit;

	int trigger_auto = -1;
	context = tii_create_context(handle, im, lang, trigger_auto);
	if(context == NULL) goto exit;

	fprintf(stderr, "IIIMCF initialization success\n");

	im_list = tii_get_im_list(handle);
	for(i = 0; im_list[i] != NULL; i++) {
		fprintf(stderr, "[message] Input method %s\n", im_list[i]);
		lang_list = tii_get_lang_list(tii_find_im(handle, im_list[i]));
		fprintf(stderr, "[message] Languages");
		for(j = 0; lang_list[j] != NULL; j++) {
			fprintf(stderr, ", %s", lang_list[j]);
		}
		fprintf(stderr, "\n");
		tii_free_list(lang_list);
	}
	tii_free_list(im_list);

	char test_ch = 0;
	if(!tii_fwd_trigger(context, 1)) goto exit;

	test_ch = getchar();
	while(test_ch != 0) {
		if(test_ch == '!') {
			if(!tii_fwd_trigger(context, 1)) goto exit;
			if(!tii_process_events(context)) goto exit;
			test_ch = getchar();
		}
		else if(test_ch == '~') {
			if(!tii_fwd_trigger(context, 0)) goto exit;
			if(!tii_process_events(context)) goto exit;
			test_ch = getchar();
		}
		else {
			if(!tii_fwd_key(context, 0, test_ch, 0)) goto exit;
			if(!tii_process_events(context)) goto exit;
			test_ch = getchar();
		}
	}

exit:
	if(context != NULL)
		tii_destroy_context(context);
	if(handle != NULL)
		tii_destroy_handle(handle);
	tii_finalize_iiimcf();

	return 0;
}
